module ani
use math_mod
implicit none
real,allocatable::qc(:,:),rc(:,:),qs(:,:),rs(:,:),weight(:)
complex,allocatable ::  dppc(:),dpmc(:),dpps(:),dpms(:)

contains


subroutine explicit_table(contablep,contablem,phi,f,dx,okx,dkx,dz,m,n,o_ep,d_ep,n_ep,o_dl,d_dl,n_dl,o_w_vp,d_w_vp,n_w_vp)
complex :: contablep(:,:,:,:),contablem(:,:,:,:)
real :: phi,f,dx,okx,dkx,dz
integer :: m,n,n_ep,n_dl,n_w_vp
real :: d_ep,d_dl,d_w_vp,o_ep,o_dl,o_w_vp


real :: ep,dl,w_vp
complex,allocatable :: conap(:),conam(:)
integer ::i_ep,i_dl,i_w_vp

allocate(conap(2*n-1),conam(2*n-1))

do i_ep=1,n_ep
  ep=(i_ep-1)*d_ep
  do i_dl=1,n_dl
    dl=(i_dl-1)*d_dl
    do i_w_vp=1,n_w_vp
       w_vp=(i_w_vp-1)*d_w_vp
 !      call  convlv_coe(phi,ep,dl,w_vp,f,dx,okx,dkx,dz,m,n,conap,conam)
       contablep(:,i_w_vp,i_dl,i_ep)=conap(:)
       contablem(:,i_w_vp,i_dl,i_ep)=conam(:)
    end do
  end do
end do 

deallocate(conap,conam)
end subroutine explicit_table

subroutine ani_init(phi,ep,dl,w_vp,f,dx,dkx,dz,m,n)
real :: phi,ep,dl,w_vp,f,dx,dkx,dz
integer :: m,n
real,allocatable :: ma(:,:),q(:,:),tmpd(:)

integer :: sing,im
allocate(qc(m,n),rc(n,n),qs(m-1,n-1),rs(n-1,n-1))
allocate(dppc(m),dpmc(m),dpps(m),dpms(m))
allocate(ma(m,n),q(m,m),tmpd(n))
!weight(1:270)=1.0; weight(271:m)=0.001

call dph(phi,ep,dl,w_vp,f,0.0,dkx,dz,m,dppc,dpmc)
call dph(phi,ep,dl,w_vp,f,0.0,-dkx,dz,m,dpps,dpms)

call phase_apro_matrix_cos(ma,dx,dkx,m,n)
do im=1,m
  ma(im,:)=ma(im,:)*weight(im)
!  write(*,*) "im",im,weight(im)
end do
call qrdcmp(ma,m,n,tmpd,sing)
call qrdpost(ma,m,n,tmpd,q,rc)
qc=q(1:m,1:n)

call phase_apro_matrix_sin(ma,dx,dkx,m,n)
do im=1,m
  ma(im,:)=ma(im,:)*weight(im)
end do

call qrdcmp(ma,m-1,n-1,tmpd,sing)
call qrdpost(ma,m-1,n-1,tmpd,q,rs)
qs=q(1:m-1,1:n-1)

deallocate(ma,q,tmpd)
end subroutine ani_init

subroutine ani_release()
deallocate(qc,rc,qs,rs,weight,dppc,dpmc,dpps,dpms)
end subroutine ani_release


subroutine convlv_coe(m,n,conapp,conapm,conamp,conamm)
integer :: m,n,sing,im
complex:: conapp(:),conapm(:),conamp(:),conamm(:),dpp1,dpp2
complex,allocatable ::  tmpconp(:),tmpconm(:)
complex,allocatable :: conaps(:)
integer :: i

allocate(tmpconp(n),tmpconm(n),conaps(n-1))
do i=1,m
  dpp1=(dppc(i)+dpps(i))/2.0
  dpp2=(dppc(i)-dpps(i))/2.0
  dppc(i)=dpp1
  dpps(i)=dpp2
end do
call qrcon(qc,rc,dppc,conapp,m,n)
call qrcon(qs,rs,dpps,conaps,m-1,n-1)
!write(*,*) conapp
do i=2,n
  conapm(i)=0.5*conapp(i)-0.5*(cmplx(0.0,1.0))*conaps(i-1)
  conapp(i)=0.5*conapp(i)+0.5*(cmplx(0.0,1.0))*conaps(i-1)
end do
deallocate(tmpconp,tmpconm,conaps)
end subroutine

subroutine phase_apro_matrix_cos(a,dx,dkx,m,n)
real::a(:,:)
real:: dx,dkx
integer :: n,m

integer :: i_m, i_n
real :: x,kx

do i_m=1,m
  kx=(i_m-1)*dkx
  do i_n=1,n
    x=(i_n-1)*dx
    a(i_m,i_n)=cos(x*kx)
  end  do
end do

end subroutine phase_apro_matrix_cos

subroutine phase_apro_matrix_sin(a,dx,dkx,m,n)
real :: a(:,:)
real :: dx,dkx
integer :: m,n

integer :: i_m,i_n
real :: x,kx

do i_m=1,m-1
  kx=i_m*dkx
  do i_n=1,n-1
    x=i_n*dx
    a(i_m,i_n)=sin(x*kx)
  end  do
end do

end subroutine phase_apro_matrix_sin


subroutine weit(phi,ep,dl,w_vp,f,okx,dkx,m)
real :: phi,ep,dl,w_vp,f,okx,dkx
integer :: m
complex :: dp,dm
complex :: kz1,kz2,kz3,kz4,kzp1,kzp2
integer :: im
real :: kx

allocate(weight(m))
do im=1,m
   kx=(im-1)*dkx+okx
   call kzani(phi,ep,dl,w_vp,f,-kx,kz1,kz2,kz3,kz4)
   call kzani(phi,ep,dl,w_vp,f,kx,kzp1,kzp2,kz3,kz4)
   if ( abs(aimag(kz1)) <0.0000001*abs(real(kz1)) .and.  abs(aimag(kzp1)) <0.0000001*abs(real(kzp1))) then
     if (real(kz1) >w_vp*0.0 .and. real(kzp1) >w_vp*0.0  ) then
       weight(im)=1.00
     else
       weight(im)=0.001
     end if
  else
     weight(im)=0.001
  end if
end do
do im=1,m
  if (weight(im)/=1.00) then
    exit
  end if
end do
weight(im-1:m)=0.001
!do im=1,m
!write(*,*)im,weight(im)
!end do
end subroutine

subroutine dph(phi,ep,dl,w_vp,f,okx,dkx,dz,m,dpp,dpm)
real :: phi,ep,dl,w_vp,f,okx,dkx,dz
integer :: m
complex :: dpp(:),dpm(:)
real :: kx
integer :: im
complex :: kz1
logical :: escent
real :: tmp
do im=1,m
  kx=(im-1)*dkx+okx
  call dphase(phi,ep,dl,w_vp,f,kx,dz,dpp(im),dpm(im),kz1)
end do


!weight(1:275)=1.0; weight(276:m)=0.001

do im=1,m
  dpp(im)=dpp(im)*weight(im)
  dpm(im)=dpp(im)*weight(im)
end do
end subroutine dph


subroutine dphase(phi,ep,dl,w_vp,f,kx,dz,dphp,dphm,kz1)
real :: phi,ep,dl,w_vp,f,kx,dz
complex :: dphp,dphm,kz1
complex :: dkzp,dkzm
real:: pshift
real :: test
real :: wt
call dkz(phi,ep,dl,w_vp,f,kx,dkzp,dkzm,kz1)
test=w_vp**2-kx**2
if (abs(real(dkzp))*0.000001 > abs(aimag(dkzp))) then
  pshift=dz*real(dkzp)
  dphp=cmplx(cos(pshift),sin(pshift))
else
  pshift=dz*(-abs(aimag(dkzp)))
  dphp=cmplx(exp(pshift),0.0)
end if
end subroutine dphase

subroutine dkz(phi,ep,dl,w_vp,f,kx,dkzp,dkzm,kkz1)
real :: phi,ep,dl,w_vp,f,kx
complex :: dkzp,dkzm,kkz1
real::kz
complex :: kz1,kz2,kz3,kz4
real :: test
real :: wt

!test=w_vp**2-kx**2
!if (test > 0.0) then
!!  call kzani(phi,ep,dl,w_vp,f,kx,kz1,kz2,kz3,kz4)
!  kz=-sqrt(w_vp**2-kx**2)
!!  dkzp=kz1-kz; dkzm=kz2-(-kz)
!  dkzp=kz
!!  if (kz1==0.0) dkzp=0.0
!!  if (kz2==0.0) dkzm=0.0
!else
!!  call kzani(phi,ep,dl,w_vp,f,kx,kz1,kz2,kz3,kz4)
!!  if (kz1==0.0) dkzp=0.0
!  dkzp=0.0 !-sqrt(w_vp**2-(w_vp*sin(3.1415926/4.0))**2)
!end if

call kzani(phi,ep,dl,w_vp,f,kx,kz1,kz2,kz3,kz4)
kkz1=kz1
test=w_vp**2-kx**2
if (test >0.0) then
  kz=sqrt(w_vp**2-kx**2)
else
  kz=0.0
end if
if ( abs(aimag(kz1)) <0.0000001*abs(real(kz1)) ) then
  dkzp=cmplx(abs(real(kz1))-kz,0.0)
else
  dkzp=cmplx(0.0,-abs(aimag(kz1)))
end if
end subroutine dkz 

subroutine kzani(phi,ep,dl,w_vp,f,kx,x1,x2,x3,x4)
real :: phi,ep,dl,w_vp,f,kx
complex :: x1,x2,x3,x4,z1,z2,z3,z4
real :: a0,a1,a2,a3,a4
integer :: i,j
call coe(a0,a1,a2,a3,a4,phi,ep,dl,w_vp,f,kx)
call p4solver(a0,a1,a2,a3,a4,z1,z2,z3,z4)
call chooseproot(z1,z2,z3,z4,x1,x2)

!write(*,*) tmpx
end subroutine kzani

subroutine coe(a0,a1,a2,a3,a4,phi,ep,dl,w_vp,f,kx)
real::a0,a1,a2,a3,a4
real::phi,ep,dl,w_vp,f,kx
real :: fm1,epdl,sin2phi,sin4phi,sinphi,cosphi,cos2phi,b1,b2

fm1=f-1
epdl=ep-dl
sin2phi=sin(2.0*phi)
cos2phi=cos(2.0*phi)
sin4phi=sin(4.0*phi)
sinphi=sin(phi)
cosphi=cos(phi)

a4=fm1+2.0*ep*fm1*sinphi**2-f/2.0*epdl*sin2phi**2
a3=(f*epdl*sin4phi-2.0*ep*fm1*sin2phi)*kx
b2=f*epdl*sin2phi**2+2.0*fm1*(1+ep)-2.0*f*epdl*cos2phi**2
a2=b2*kx**2+w_vp**2*(2.0+2.0*ep*sinphi**2-f) 
b1=2.0*ep*(-fm1)*sin2phi-f*epdl*sin4phi
a1=b1*kx**3-2.0*ep*sin2phi*w_vp**2*kx
a0=(2.0+2.0*ep*cosphi**2-f)*w_vp**2*kx**2-w_vp**4-(-fm1*(1.0+2.0*ep*cosphi**2)+f/2.0*epdl*sin2phi**2)*kx**4
end subroutine coe


end module ani
