program impulse
use sep3d_struct_mod
use shot_kernal_mod
use data_mod
use  velocity_mod
implicit none

type(sep3d)::wavefld,dirfld,dirin
logical :: is2d
integer :: nx,ny,nz,nw,nref
real :: dx,dy,dz,min_x,max_x,dw,w0
integer :: op
real :: fd_a,fd_b,fd_trick,tantheta2,sintheta2,sintheta


integer :: i_w,iz,ix,iy,k,oop
real :: w,sx,tilt,w_vp
real,allocatable :: vel(:,:,:),velani(:,:),epa(:,:,:),dla(:,:,:)
complex,allocatable :: wld(:,:),wld_mono(:,:,:),dir(:,:,:)
integer :: op_p
integer,external :: srite,sreed


call initpar()
call from_param('mig_nz',nz,1000)
call from_param('mig_dz',dz,4.0)
call from_param('modl_dx',dx,20.0)
call from_param('min_x',min_x,-6000.0)
call from_param('max_x',max_x,14000.0)
call from_param('sx',sx,4000.0)
call from_param('operator',op,1)
call from_param('operator_a',fd_a,0.5)
call from_param('operator_b',fd_b,0.0)
call from_param('fd_trick',fd_trick,0.14)
call from_param('nref',nref,3)
!call from_param('ep',ep,0.4)
!call from_param('dl',dl,0.2)
call from_param('oop',oop,0)
call from_param('tilt',tilt,3.1415926/6.0)
call from_param('op_p',op_p,1)  ! 1 ico, 2 for icoffd,3 for phsift

is2d=.true.
ny=1; dy=20.0


nx=(max_x-min_x)/dx+1
if ( mod(nx,2)==1 ) nx=nx+1
!nx=100.0
!call velocity_mod_init(dx,dy,dz,is2d,0)
dx=5.0; dy=5.0; dz=4.0
is2d=.true.


allocate( vel(nz,nx,ny),dla(nz,nx,ny),epa(nz,nx,ny),wld(nx,ny),wld_mono(nx,ny,nz),dir(nx,ny,nz),velani(nx,ny))
!call velocity_read(min_x,0.0,0.0,nx,ny,nz,vel,is2d,-0.1,1)
vel=2000.0


call data_mod_init_modeling(nw,dx,dw,w0)


write(*,*)"abc"
call init_sep3d(wavefld,"OUTPUT","COMPLEX","REGULAR", ctag="Wavefield")
call axis_allocate(wavefld,4)
wavefld%n(1)=nx; wavefld%d(1)=dx; wavefld%o(1)=min_x
wavefld%n(2)=ny; wavefld%d(2)=dx; wavefld%o(2)=0.0
wavefld%n(3)=nz; wavefld%d(3)=dz; wavefld%o(3)=0.0
wavefld%n(4)=nw; wavefld%d(4)=dw; wavefld%o(4)=w0
call sep3d_set_sep3d(wavefld)
call sep3d_write_description("Wavefield",wavefld)


call shot_ker_init(nx,ny,nref)
 
write(*,*)"nx",nx
call ker_p_init(op,nx,ny,dx,dy,dz,fd_a,fd_b,fd_trick,is2d)
write(*,*)"aaa"

!do i_w=nw*3.0/4.0,nw*3.0/4.0
do i_w=1,nw
   w=(i_w-1)*dw+w0
   w_vp=w/2000.0
   write(*,*) "iw=",i_w,"w=",w,"nw=",nw
   call ker_p_ani_init(w_vp) 
   call data_source_modeling(sx,min_x,nx,wld,i_w)
   do iz=1,nz
!     write(*,*)"iz",iz
     velani(:,:)=vel(iz,:,:)
     
!     write(*,*)maxval(abs(wld))
     call shot_ker_depth_onestep(wld,velani(:,:),w,-1,op_p)
!     write(*,*)maxval(abs(wld))
     wld_mono(:,:,iz)=wld
   end do
   if ( srite("Wavefield",wld_mono,nx*ny*nz*8)/= nx*ny*nz*8 ) call seperr("err write wavefld")
end do


call shot_ker_release
deallocate (vel,wld,wld_mono,dir,velani)
end program impulse
