program infft
use sep3d_struct_mod
use sep
implicit none
type(sep3d):: datain, dataout

integer :: nt,nx,nw,iw_min,iw_max,ix,block_size,outnt
integer :: n_dim,i_dim,n_trace
real :: dw,dt
complex :: tmp_fft(:),fft(:)
integer,external :: sreed,srite

call initpar()
call from_param("dt",dt,0.002)
call from_param("outnt",outnt,1500)


call init_sep3d("in",datain,"INPUT")
n_dim=size(datain%n)


call init_sep3d(dataout,"OUTPUT","FLOAT","REGULAR",ctag="out"); 
call axis_allocate(dataout,n_dim)
dw=datain%d(1); nw=datain%n(1)
iw_min=datain%o(1)/dw; iw_max=iw_min+nw-1
write(0,*) "dw",dw
nt=2.0*3.1415926/(dt*dw)
if (mod(nt,2)==1) nt=nt+1
write(0,*)"aaaaaaaa", nt
if (outnt > nt) call seperr("outnt >nt")
dataout%o(1)=0.0; dataout%d(1)=dt; dataout%n(1)=outnt
n_trace=1
do i_dim=2,n_dim
  n_trace=n_trace*datain%n(i_dim)
  dataout%o(i_dim)=datain%o(i_dim)
  dataout%d(i_dim)=datain%d(i_dim)
  dataout%n(i_dim)=datain%n(i_dim)
end do
call sep3d_set_sep3d(dataout) 
call sep3d_write_description("out",dataout)

write(0,*) n_dim,n_trace



allocate(tmp_fft(nt),fft(nw))
write(0,*) outnt,"bbbbbbbbbbbbbb"

block_size=nw*8
do ix=1,n_trace
  if(sreed("in",fft,block_size)/=block_size ) call seperr("Error reading")
  tmp_fft=0.0
  tmp_fft(iw_min:iw_max)=fft
  call CFFT1DE(tmp_fft,nt,-1) 
  if(srite("out",real(tmp_fft(1:outnt)),outnt*4)/=outnt*4 ) call seperr("Error writing")  
end do

deallocate(tmp_fft,fft)
end program infft
